<template>
  <div v-if="isChecked">
    <button :disabled="loading || isAuth" @click="login">connect</button>
    <p>{{ account }}</p>
    <br />
    <form>
      <input v-model="accountId" :disabled="loading" id="account-id" />
      <button
        :disabled="loading || !accountId || !isAuth"
        @click.prevent="calcValue"
      >
        calc
      </button>
    </form>
    <br />
    <p v-if="balance">Balance: {{ balance }}</p>
  </div>
</template>

<script>
import { checkAccounts, loginMetamask } from "./utils";
import { mapState, mapGetters } from "vuex";
import { ethers } from "ethers";
const contractAddress = "0xf16e81dce15B08F326220742020379B855B87DF9";

export default {
  name: "App",
  data: () => ({
    loading: false,
    accountId: "",
    balance: null,
    isChecked: false,
  }),
  computed: {
    ...mapState(["account"]),
    ...mapGetters(["isAuth"]),
  },
  methods: {
    async login() {
      try {
        this.loading = true;
        await loginMetamask();
      } catch (e) {
        console.error(e);
      } finally {
        this.loading = false;
      }
    },
    async check() {
      try {
        await checkAccounts();
      } catch (e) {
        console.error(e);
      } finally {
        this.isChecked = true;
      }
    },
    async calcValue() {
      try {
        this.loading = true;
        const abi = await fetch(
          `https://api.etherscan.io/api?module=contract&action=getabi&address=${contractAddress}`
        )
          .then((r) => r.json())
          .then((json) => json.result);

        const provider = new ethers.providers.Web3Provider(window.ethereum);

        const contract = new ethers.Contract(contractAddress, abi, provider);

        const balanceData = await contract.balanceOf(this.accountId);
        const decimals = await contract.decimals();

        this.balance = ethers.utils.formatUnits(balanceData, decimals);
      } catch (e) {
        console.error(e);
      } finally {
        this.loading = false;
      }
    },
  },
  mounted() {
    this.check();
  },
};
</script>

<style></style>
